	.macro print_reg(%reg, %rn)
.data
string: .ascii %rn, ": ", "\0"
.text	
	la 		$a0, string
	li 		$v0, 4
	syscall

	move 	$a0, %reg
	li 		$v0, 1
	syscall
	
	li 		$a0, '\n'
	li 		$v0, 11
	syscall
	.end_macro

.data
    .globl main

# Memory layout of the Configuration
# |   eca  |   tape   |  tape_len  |  rule  |  skip  | column |
# | 1 word |  1 word  |   1 byte   | 1 byte | 1 byte | 1 byte |
automaton:
  .word 0       	# eca
  .word 31415926  # tape
  .byte 29       	# tape_len
  .byte 75     		# rule
  .byte 10       	# skip
  .byte 19       	# column


.text

main:
  li $v0 40 # set seed syscall
  li $a0 0 # rng id
  lw $a1 automaton+4 # seed
  syscall 
  
  li $s0 30 # loop counter
  li $s1, -1374330824
  li $s2, -917611798
  li $s3, -91021595
  li $s4, 1324399736
  li $s5, -1258021150
  li $s6, 108639881
  li $s7, -1841224898
  
loop:
  beqz $s0 terminate
  subi $s0 $s0 1
  la $a0 automaton
  jal gen_bit
  # print returned value
  move $a0 $v0
  li $v0 1
  syscall
  j loop
terminate:

	li 		$a0, '\n'
	li 		$v0, 11
	syscall

	print_reg($s0, "$s0")
	print_reg($s1, "$s1")
	print_reg($s2, "$s2")
	print_reg($s3, "$s3")
	print_reg($s4, "$s4")
	print_reg($s5, "$s5")
	print_reg($s6, "$s6")
	print_reg($s7, "$s7")


  li      $v0 10
  syscall
